let zero_rational = (0, 1);;

let lcm a b =
 let rec lcm x y =
  if x = y then x else
  if x < y then lcm (x + a) y
           else lcm x (y + b) in
 lcm a b;;

let rec gcd a b =
 if b = 0 then a else gcd b (a mod b);;

let abs x = if x < 0 then -x else x;;

let reduce_rational (x, y) =
 if y = 0 then raise Division_by_zero else
 if x = 0 then (0, 1) else
 let z = abs (gcd x y) in (x / z, y / z);;

let ( +| ) (a, b) (c, d) = reduce_rational (a * d + b * c, b * d);;
let ( -| ) (a, b) (c, d) = reduce_rational (a * d - b * c, b * d);;
let ( *| ) (a, b) (c, d) = reduce_rational (a * c, b * d);;
let ( /| ) (a, b) (c, d) = reduce_rational (a * d, b * c);;

let comp_rationals (a, b) (c, d) =
 let z = lcm b d in
 let (bb, dd) = (z / b, z / d) in
 (a * dd) > (c * bb);;

let min_rational x y = if comp_rationals x y then y else x;;

let negate_rational (x, y) = (-x, y);;
let revert_rational (x, y) = ( y, x);;